var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { isNull, isNumber, isUndefined, nth } from 'lodash';
import React, { useImperativeHandle, useRef, useState } from 'react';
import ReactDOM from 'react-dom';
import { useEvent, useEventCallback, useId, useImmer, useRefExtra } from '@react-devui/hooks';
import { getClassName, getVerticalSidePosition, scrollToView } from '@react-devui/utils';
import { useMaxIndex, useDValue } from '../../hooks';
import { registerComponentMate, TTANSITION_DURING_POPUP, WINDOW_SPACE } from '../../utils';
import { ESC_CLOSABLE_DATA } from '../../utils/checkNoExpandedEl';
import { DFocusVisible } from '../_focus-visible';
import { DPopup, useNestedPopup } from '../_popup';
import { DTransition } from '../_transition';
import { useComponentConfig, usePrefixConfig, useTranslation } from '../root';
import { DSeparator } from '../separator';
import { DGroup } from './Group';
import { DItem } from './Item';
import { DSub } from './Sub';
import { checkEnableItem, getSameLevelEnableItems } from './utils';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DDropdown' });
function Dropdown(props, ref) {
    var _a, _b;
    const _c = useComponentConfig(COMPONENT_NAME, props), { children, dList, dVisible, dPlacement = 'bottom-right', dTrigger = 'hover', dArrow = false, dZIndex, onVisibleChange, onItemClick, afterVisibleChange } = _c, restProps = __rest(_c, ["children", "dList", "dVisible", "dPlacement", "dTrigger", "dArrow", "dZIndex", "onVisibleChange", "onItemClick", "afterVisibleChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const windowRef = useRefExtra(() => window);
    const dropdownRef = useRef(null);
    const childRef = useRefExtra(() => document.getElementById(triggerId));
    const ulRef = useRef(null);
    const containerRef = useRefExtra(() => {
        let el = document.getElementById(`${dPrefix}dropdown-root`);
        if (!el) {
            el = document.createElement('div');
            el.id = `${dPrefix}dropdown-root`;
            document.body.appendChild(el);
        }
        return el;
    }, true);
    //#endregion
    const dataRef = useRef({
        updatePosition: new Map(),
    });
    const [t] = useTranslation();
    const uniqueId = useId();
    const id = (_a = restProps.id) !== null && _a !== void 0 ? _a : `${dPrefix}dropdown-${uniqueId}`;
    const triggerId = (_b = children.props.id) !== null && _b !== void 0 ? _b : `${dPrefix}dropdown-trigger-${uniqueId}`;
    const getItemId = (id) => `${dPrefix}dropdown-item-${id}-${uniqueId}`;
    const [loadingIds, setLoadingIds] = useImmer(new Set());
    const { popupIds, setPopupIds, addPopupId, removePopupId } = useNestedPopup();
    const [focusIds, setFocusIds] = useState([]);
    const [isFocus, setIsFocus] = useState(false);
    const [focusVisible, setFocusVisible] = useState(false);
    const focusId = (() => {
        var _a;
        if (isFocus) {
            let id;
            for (const [index, focusId] of focusIds.entries()) {
                id = focusId;
                if (((_a = nth(popupIds, index)) === null || _a === void 0 ? void 0 : _a.id) !== focusId) {
                    break;
                }
            }
            return id;
        }
    })();
    const focusFirst = () => {
        const ids = [];
        const reduceArr = (arr) => {
            for (const item of arr) {
                if (ids.length === 1) {
                    break;
                }
                if (item.type === 'group' && item.children) {
                    reduceArr(item.children);
                }
                else if (checkEnableItem(item)) {
                    ids.push(item.id);
                }
            }
        };
        reduceArr(dList);
        setFocusIds(ids);
    };
    const focusLast = () => {
        const ids = [];
        const reduceArr = (arr) => {
            for (let index = arr.length - 1; index >= 0; index--) {
                if (ids.length === 1) {
                    break;
                }
                const item = arr[index];
                if (item.type === 'group' && item.children) {
                    reduceArr(item.children);
                }
                else if (checkEnableItem(item)) {
                    ids.push(item.id);
                }
            }
        };
        reduceArr(dList);
        setFocusIds(ids);
    };
    const [visible, _changeVisible] = useDValue(false, dVisible, onVisibleChange);
    const changeVisible = (visible) => {
        if (!visible) {
            setPopupIds([]);
        }
        _changeVisible(visible);
    };
    const maxZIndex = useMaxIndex(visible);
    const zIndex = (() => {
        if (isUndefined(dZIndex)) {
            return maxZIndex;
        }
        else {
            return dZIndex;
        }
    })();
    const [popupPositionStyle, setPopupPositionStyle] = useState({
        top: '-200vh',
        left: '-200vw',
    });
    const [transformOrigin, setTransformOrigin] = useState();
    const [arrowPosition, setArrowPosition] = useState();
    const updatePosition = useEventCallback(() => {
        if (visible && childRef.current && dropdownRef.current) {
            const [width, height] = [dropdownRef.current.offsetWidth, dropdownRef.current.offsetHeight];
            const { top, left, transformOrigin, arrowPosition } = getVerticalSidePosition(childRef.current, { width, height }, {
                placement: dPlacement,
                inWindow: WINDOW_SPACE,
            });
            setPopupPositionStyle({ top, left });
            setTransformOrigin(transformOrigin);
            setArrowPosition(arrowPosition);
        }
    });
    const preventBlur = (e) => {
        if (e.button === 0) {
            e.preventDefault();
        }
    };
    useEvent(windowRef, 'keydown', (e) => {
        if (e.code === 'Escape') {
            changeVisible(false);
        }
    }, {}, !visible);
    let handleKeyDown;
    const nodes = (() => {
        const getNodes = (arr, level, subParents) => arr.map((item) => {
            const { id: itemId, label: itemLabel, type: itemType, icon: itemIcon, disabled: itemDisabled = false, separator: itemSeparator, children, } = item;
            const newSubParents = itemType === 'sub' ? subParents.concat([item]) : subParents;
            const id = getItemId(itemId);
            const isFocus = itemId === focusId;
            const isEmpty = !(children && children.length > 0);
            const popupState = popupIds.find((v) => v.id === itemId);
            const handleItemClick = () => {
                const shouldClose = onItemClick === null || onItemClick === void 0 ? void 0 : onItemClick(itemId, item);
                setFocusIds(subParents.map((parentItem) => parentItem.id).concat([itemId]));
                if (shouldClose instanceof Promise) {
                    setLoadingIds((draft) => {
                        draft.add(itemId);
                    });
                    shouldClose.then(() => {
                        setLoadingIds((draft) => {
                            draft.delete(itemId);
                        });
                    });
                }
                else if (shouldClose !== false) {
                    changeVisible(false);
                }
            };
            if (isFocus) {
                handleKeyDown = (e) => {
                    var _a, _b, _c, _d;
                    const sameLevelItems = getSameLevelEnableItems((_b = (_a = nth(subParents, -1)) === null || _a === void 0 ? void 0 : _a.children) !== null && _b !== void 0 ? _b : dList);
                    const focusItem = (val) => {
                        if (val) {
                            setFocusIds(subParents.map((parentItem) => parentItem.id).concat([val.id]));
                        }
                    };
                    const scrollToItem = (val) => {
                        if (val) {
                            const el = document.getElementById(getItemId(val.id));
                            if (el && ulRef.current) {
                                scrollToView(el, ulRef.current, 4);
                            }
                        }
                    };
                    switch (e.code) {
                        case 'ArrowUp': {
                            e.preventDefault();
                            const index = sameLevelItems.findIndex((sameLevelItem) => sameLevelItem.id === itemId);
                            const item = nth(sameLevelItems, index - 1);
                            focusItem(item);
                            scrollToItem(item);
                            if (item && ((_c = nth(popupIds, -1)) === null || _c === void 0 ? void 0 : _c.id) === itemId) {
                                setPopupIds(popupIds.slice(0, -1));
                            }
                            break;
                        }
                        case 'ArrowDown': {
                            e.preventDefault();
                            const index = sameLevelItems.findIndex((sameLevelItem) => sameLevelItem.id === itemId);
                            const item = nth(sameLevelItems, (index + 1) % sameLevelItems.length);
                            focusItem(item);
                            scrollToItem(item);
                            if (item && ((_d = nth(popupIds, -1)) === null || _d === void 0 ? void 0 : _d.id) === itemId) {
                                setPopupIds(popupIds.slice(0, -1));
                            }
                            break;
                        }
                        case 'ArrowLeft': {
                            e.preventDefault();
                            setPopupIds(popupIds.slice(0, -1));
                            const ids = subParents.map((item) => item.id);
                            if (ids.length > 0) {
                                setFocusIds(ids);
                            }
                            break;
                        }
                        case 'ArrowRight':
                            e.preventDefault();
                            if (itemType === 'sub') {
                                addPopupId(itemId);
                                if (children) {
                                    const newFocusItem = nth(getSameLevelEnableItems(children), 0);
                                    if (newFocusItem) {
                                        setFocusIds(newSubParents.map((parentItem) => parentItem.id).concat([newFocusItem.id]));
                                    }
                                }
                            }
                            break;
                        case 'Home':
                            e.preventDefault();
                            focusItem(nth(sameLevelItems, 0));
                            if (ulRef.current) {
                                ulRef.current.scrollTop = 0;
                            }
                            break;
                        case 'End':
                            e.preventDefault();
                            focusItem(nth(sameLevelItems, -1));
                            if (ulRef.current) {
                                ulRef.current.scrollTop = ulRef.current.scrollHeight;
                            }
                            break;
                        case 'Enter':
                        case 'Space':
                            e.preventDefault();
                            if (itemType === 'item') {
                                handleItemClick();
                            }
                            else if (itemType === 'sub') {
                                addPopupId(itemId);
                            }
                            break;
                        default:
                            break;
                    }
                };
            }
            return (_jsxs(React.Fragment, { children: [itemType === 'item' ? (_jsx(DItem, Object.assign({ dId: id, dLevel: level, dIcon: itemIcon, dFocusVisible: focusVisible && isFocus, dLoading: loadingIds.has(itemId), dDisabled: itemDisabled, onItemClick: handleItemClick }, { children: itemLabel }))) : itemType === 'group' ? (_jsx(DGroup, Object.assign({ dId: id, dLevel: level, dList: children && getNodes(children, level + 1, newSubParents), dEmpty: isEmpty }, { children: itemLabel }))) : (_jsx(DSub, Object.assign({ ref: (fn) => {
                            if (isNull(fn)) {
                                dataRef.current.updatePosition.delete(itemId);
                            }
                            else {
                                dataRef.current.updatePosition.set(itemId, fn);
                            }
                        }, dId: id, dLevel: level, dList: children && getNodes(children, 0, newSubParents), dPopupState: popupState === null || popupState === void 0 ? void 0 : popupState.visible, dTrigger: dTrigger, dZIndex: isUndefined(zIndex)
                            ? zIndex
                            : isNumber(zIndex)
                                ? zIndex + 1 + subParents.length
                                : `calc(${zIndex} + ${1 + subParents.length})`, dIcon: itemIcon, dEmpty: isEmpty, dFocusVisible: focusVisible && isFocus, dDisabled: itemDisabled, onVisibleChange: (visible) => {
                            if (visible) {
                                if (subParents.length === 0) {
                                    setPopupIds([{ id: itemId, visible: true }]);
                                }
                                else {
                                    addPopupId(itemId);
                                }
                            }
                            else {
                                removePopupId(itemId);
                            }
                        } }, { children: itemLabel }))), itemSeparator && _jsx(DSeparator, { style: { margin: '2px 0' } })] }, itemId));
        });
        return getNodes(dList, 0, []);
    })();
    useImperativeHandle(ref, () => ({
        updatePosition: () => {
            updatePosition();
            for (const fn of dataRef.current.updatePosition.values()) {
                fn();
            }
        },
    }), [updatePosition]);
    return (_jsx(DPopup, Object.assign({ dVisible: visible, dTrigger: dTrigger, dUpdatePosition: {
            fn: updatePosition,
            triggerRef: childRef,
            popupRef: ulRef,
            extraScrollRefs: [],
        }, onVisibleChange: changeVisible }, { children: ({ renderTrigger, renderPopup }) => (_jsxs(_Fragment, { children: [_jsx(DFocusVisible, Object.assign({ onFocusVisibleChange: setFocusVisible }, { children: ({ render: renderFocusVisible }) => {
                        var _a;
                        return renderFocusVisible(renderTrigger(React.cloneElement(children, {
                            id: triggerId,
                            tabIndex: (_a = children.props.tabIndex) !== null && _a !== void 0 ? _a : 0,
                            role: 'button',
                            'aria-haspopup': 'menu',
                            'aria-expanded': visible,
                            'aria-controls': id,
                            [ESC_CLOSABLE_DATA]: visible,
                            onFocus: (e) => {
                                var _a, _b;
                                (_b = (_a = children.props).onFocus) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                setIsFocus(true);
                                focusFirst();
                            },
                            onBlur: (e) => {
                                var _a, _b;
                                (_b = (_a = children.props).onBlur) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                setIsFocus(false);
                                changeVisible(false);
                            },
                            onKeyDown: (e) => {
                                var _a, _b;
                                (_b = (_a = children.props).onKeyDown) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                if (visible) {
                                    handleKeyDown === null || handleKeyDown === void 0 ? void 0 : handleKeyDown(e);
                                }
                                else {
                                    switch (e.code) {
                                        case 'Enter':
                                        case 'Space':
                                        case 'ArrowDown':
                                            e.preventDefault();
                                            focusFirst();
                                            changeVisible(true);
                                            break;
                                        case 'ArrowUp':
                                            e.preventDefault();
                                            focusLast();
                                            changeVisible(true);
                                            break;
                                        default:
                                            break;
                                    }
                                }
                            },
                        })));
                    } })), containerRef.current &&
                    ReactDOM.createPortal(_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING_POPUP, onEnter: updatePosition, afterEnter: () => {
                            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
                        }, afterLeave: () => {
                            afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
                        } }, { children: (state) => {
                            let transitionStyle = {};
                            switch (state) {
                                case 'enter':
                                    transitionStyle = { transform: 'scaleY(0.7)', opacity: 0 };
                                    break;
                                case 'entering':
                                    transitionStyle = {
                                        transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-out`).join(', '),
                                        transformOrigin,
                                    };
                                    break;
                                case 'leaving':
                                    transitionStyle = {
                                        transform: 'scaleY(0.7)',
                                        opacity: 0,
                                        transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-in`).join(', '),
                                        transformOrigin,
                                    };
                                    break;
                                case 'leaved':
                                    transitionStyle = { display: 'none' };
                                    break;
                                default:
                                    break;
                            }
                            return renderPopup(_jsxs("div", Object.assign({ ref: dropdownRef }, restProps, { className: getClassName(restProps.className, `${dPrefix}dropdown`), style: Object.assign(Object.assign(Object.assign(Object.assign({}, restProps.style), popupPositionStyle), { zIndex }), transitionStyle), onMouseDown: (e) => {
                                    var _a;
                                    (_a = restProps.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                                    preventBlur(e);
                                }, onMouseUp: (e) => {
                                    var _a;
                                    (_a = restProps.onMouseUp) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                                    preventBlur(e);
                                } }, { children: [_jsx("ul", Object.assign({ ref: ulRef, id: id, className: `${dPrefix}dropdown__list`, tabIndex: -1, role: "menu", "aria-labelledby": triggerId, "aria-activedescendant": isUndefined(focusId) ? undefined : getItemId(focusId) }, { children: dList.length === 0 ? _jsx("div", Object.assign({ className: `${dPrefix}dropdown__empty` }, { children: t('No Data') })) : nodes })), dArrow && _jsx("div", { className: `${dPrefix}dropdown__arrow`, style: arrowPosition })] })));
                        } })), containerRef.current)] })) })));
}
export const DDropdown = React.forwardRef(Dropdown);
